
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>第1章 重构，第一个案例（3）：运用多态取代switch / 憋错料</title>

    <meta name="description" content="第1章 重构，第一个案例（3）：运用多态取代switch 3. 运用多态取代与价格相关的条件逻辑 3.1 switch和“常客积分”代码的再次搬迁 (1)switch:最好不要在另一个对象的属性上运用switch语句 switch(getMovie().getPriceCode()) //在movie对象的priceCode属性上运用switch { //这意味着可以将getCharge函数从Rental类移动到Movie类去 //选择在Movie类中封装计算费用功能,还有一个 //原因,就是可以控制因影片类型变化导致的计算 //方式变化,从而对其它对">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">第1章 重构，第一个案例（3）：运用多态取代switch</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>3. </strong><strong>运用多态取代与价格相关的条件逻辑</strong></p>
<p><strong>3.1 switch</strong><strong>和&ldquo;常客积分&rdquo;代码的再次搬迁</strong></p>
<p>（1）<strong>switch</strong>：最好不要在另一个对象的属性上运用switch语句</p>
<pre>switch(getMovie().getPriceCode())   //在movie对象的priceCode属性上运用switch
{                                   //这意味着可以将getCharge函数从Rental类移动到Movie类去
                                    //选择在Movie类中封装计算费用功能，还有一个
                                    //原因，就是可以控制因影片类型变化导致的计算
                                    //方式变化，从而对其它对象产生影响。
   &hellip;</pre>
<pre>}</pre>
<p>（2）<strong>常客积分</strong>：getFrequentRenterPoints函数的再次搬迁。用跟处理getCharge相同的手法处理常客积分，将因影片类型变化而变化的所有东西都放到Movie类中去处理。Rental类中只需调用Movie相应的方法即可。</p>
<p>【实例分析】影片出租1.3.1</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzc3Mjc1OS8yMDE2MTAvNzcyNzU5LTIwMTYxMDAxMjE1ODQ5NDM4LTE5MzUyNjU3NDAucG5n.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>//第1章：重构，第1个案例
//场景：影片出租，计算每一位顾客的消费金额
/*
说明：
1. 影片分3类：普通片、儿童片和新片。
2. 每种影片计算租金的方式。
   A.普通片：基本租金为2元，超过2天的部分每天加1.5元
   B.新片：租期*3
   C.儿童片：基本租金为1.5元，超过3天的部分每天加1.5元
3. 积分的计算：每借1片，积分加1，如果是新片且租期1天以上的额外赠送1分。
*/
#include &lt;iostream&gt;
#include &lt;vector&gt;
#include &lt;string&gt;
#include &lt;sstream&gt;
using namespace std;

//影片类
class Movie
{
private:
    string title; //片名
    int priceCode; //价格

public:
    enum MovieType{
        REGULAR = 0, //普通片
        NEW_RELEASE, //新片
        CHILDRENS    //儿童片
    };

    Movie(string title, int priceCode)
    {
        this-&gt;title = title;
        this-&gt;priceCode = priceCode;
    }

    string getTitle(){return title;}
    void setTitle(string value)
    {
        title = value;
    }

    int getPriceCode(){return priceCode;}
    void setPriceCode(int value)
    {
        this-&gt;priceCode = value;
    }

    //将原来Rental类中的getCharge移到该类中,并将租期作为参数传入
    //搬到这里来的原因是
    //1.switch语句中getPriceCode为本类对象的属性
    //2.封装影片类型的变化导致计算方式变化于该类中，从而降低对其他类的影响
    double getCharge(int daysRented)
    {
        double result = 0 ;//相当于statement中的thisamount;

        switch(getPriceCode())
        {
        case Movie::REGULAR:
            result += 2;    //普通片基本租金为2元
            if(daysRented &gt; 2)  //超过2天的每天加1.5元
                result +=(daysRented - 2 ) * 1.5;
            break;
        case Movie::NEW_RELEASE:
            result += daysRented * 3;    //新片的租金
            break;
        case Movie::CHILDRENS:
            result += 1.5;    //儿童片基本租金为1.5元
            if(daysRented &gt; 3)  //超过3天的每天加1.5元
                result +=(daysRented - 3 ) * 1.5;
            break;
        }

       return result;
    }

    //将原Rental类中常客积分搬到该类中
    //原因是常客积分的计费方式与影片类型有关，也是为了控制当
    //影片类型变化时，由于计算方式变化对其他类的影响
    int getFrequentRenterPoints(int daysRented)
    {
        //如果是新片且租期超过1天以上，则额外送1分积分
        if ((getPriceCode() == Movie::NEW_RELEASE) &amp;&amp;
            daysRented &gt; 1 )  return 2;
        else  return 1;
    }
};

//租赁类（表示某个顾客租了一部影片）
class Rental
{
private:
    Movie&amp; movie;   //所租的影片
    int daysRented; //租期
public:
    Rental(Movie&amp; movie, int daysRented):movie(movie)
    {
        this-&gt;daysRented = daysRented;
    }

    int getDaysRented(){return daysRented;}

    Movie&amp; getMovie()
    {
        return movie;
    }

    double getCharge()
    {
        return movie.getCharge(daysRented);
    }

    //将原Customer类的statement中计算常客积分的代码移到Rental类
    int getFrequentRenterPoints()
    {
        return movie.getFrequentRenterPoints(daysRented);
    }
};

//顾客类（用来表示顾客）
class Customer
{
private:
    string name; //顾客姓名
    vector&lt;Rental*&gt; rentals; //每个租赁记录

     //获得总消费
     double getTotalCharge()
     {
        double result = 0;
        vector&lt;Rental*&gt;::iterator iter = rentals.begin();
        while( iter != rentals.end())
        {
            Rental&amp; each = *(*iter);

            result += each.getCharge();

            ++iter;
        }
        return result;
     }

     //获得总积分
    int getTotalFrequentRenterPointers()
    {
        int result = 0;

        vector&lt;Rental*&gt;::iterator iter = rentals.begin();
        while( iter != rentals.end())
        {
            Rental&amp; each = *(*iter);

            result += each.getFrequentRenterPoints();

            ++iter;
         }

         return result;
     }

     void cleanUp()
     {
         vector&lt;Rental*&gt;::iterator iter = rentals.begin();
         while( iter != rentals.end())
         {
             delete(*iter);
            ++iter;
         }
         rentals.clear();
     }

     template &lt;typename T&gt;
     string numToString(T num)
     {
         stringstream ss;
         ss &lt;&lt; num;
         return ss.str();
     }

public:
    Customer(string name)
    {
        this-&gt;name = name;
    }

    void addRental(Rental* value)
    {
        rentals.push_back(value);
    }

    string getName(){return name;}

    //statement(报表)，生成租赁的详单
    string statement()
    {
        string ret = "Rental Record for " + name + "\n";

        vector&lt;Rental*&gt;::iterator iter = rentals.begin();
        while( iter != rentals.end())
        {
            Rental&amp; each = *(*iter);

            //显示每个租赁记录

            ret += "\t" + each.getMovie().getTitle() + "\t" +
                 numToString(each.getCharge())+ "\n";

            ++iter;
        }

        //增加页脚注释
        ret += "Amount owed is " + numToString(getTotalCharge()) + "\n";//用getTotalCharge代替totalAmount
        ret += "You earned " + numToString(getTotalFrequentRenterPointers()) +"\n";

        return ret;
    }

    ~Customer()
    {
        cleanUp();
    }
};

void init(Customer&amp; customer)
{
    Movie* mv = new Movie("倚天屠龙记",Movie::REGULAR);
    Rental* rt = new Rental(*mv, 2);
    customer.addRental(rt);

    mv = new Movie("新水浒传",Movie::NEW_RELEASE);
    rt = new Rental(*mv, 3);
    customer.addRental(rt);

    mv = new Movie("喜羊羊与灰太狼",Movie::CHILDRENS);
    rt = new Rental(*mv, 5);
    customer.addRental(rt);
}

int main()
{
    Customer customer("SantaClaus");
    init(customer);

    cout &lt;&lt; customer.statement() &lt;&lt;endl;

    return 0;
}
/*输出结果
Rental Record for SantaClaus
        倚天屠龙记      2
        新水浒传        9
        喜羊羊与灰太狼  4.5
Amount owed is 15.5
You earned 4
*/</pre>
<p></p>
<p><strong>3.2 </strong><strong>运用子类取代类型码</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzc3Mjc1OS8yMDE2MTAvNzcyNzU5LTIwMTYxMDAxMjE1OTM2ODc1LTIwMjgyNTc2NDcucG5n.jpg" /></p>
<p>（1）使用<strong>继承子类</strong>的方式，可以<strong>利用多态来取代switch语句</strong>。</p>
<p><strong>（2）重构的步骤</strong></p>
<p>　　①使用&ldquo;<strong>自我封装字段</strong>&rdquo;的方法将类型码通过get/set函数封装起来（如Movie类的getPriceCode函数）。如果类型码被传递给构造函数，就需要将构造函数换成工厂方法（如createMovie函数）</p>
<p>　　②以类型码的<strong>宿主类</strong>为基类，为类型码的<strong>每一个数值建立一个相应的子类</strong>。在每个子类中覆写类型码的取值函数，使其返回相应的类型码值。（见Movie子类getPriceCode）</p>
<p>　　③从父类中<strong>删除保存类型码的字段</strong>(即旧Movie类的priceCode字段)，将<strong>类型码访问函数声明为抽象函数</strong>（如Movie中的getPriceCode）</p>
<p>　　④使用pushDownMethod/Field方法将<strong>与特定类型码相关的函数</strong>推到<strong>子类</strong>来实现（如本例中的getCharge函数）</p>
<p><strong>（3）缺点：</strong></p>
<p>　　①<strong>对于某个具体对象，在其生命周期中其状态（或本例中类型码）是不可改变的</strong>（如代表Movie子类型的priceCode是不能更改的），所以当创建了一部影片出来以后，就不能修改其类型了。如，现在某影片是&ldquo;新片&rdquo;类型，但即使随着时间的推移，也不能更改为&ldquo;普通片&rdquo;或&ldquo;儿童片&rdquo;了。</p>
<p>　　②我们<strong>总是在避免使用switch语句，虽然利用了多态将各个case语句的代码分解到相应的子类中去实现</strong>。但在Movie类的createMovie函数中仍然要出现switch语句。幸运的是，仅此一处用到switch,并且<strong>只用于决定创建何种对象而没有其他的业务逻辑</strong>，所以<strong>这样的switch语句是可以接受的</strong>。</p>
<p>【实例分析】影片出租1.3.2</p>
<p>//types.h</p>
<pre>#include &lt;vector&gt;
#include &lt;string&gt;
#include &lt;sstream&gt;
using namespace std;

//影片类
class Movie
{
private:
    string title; //片名
    //int priceCode; //价格，注意，这里被注释了

public:
    enum MovieType{
        REGULAR = 0, //普通片
        NEW_RELEASE, //新片
        CHILDRENS    //儿童片
    };

    Movie(string title);

    static Movie* createMovie(string title, int priceCode);

    string getTitle();
    void setTitle(string value);

    //类型码的&ldquo;自我封装&rdquo;（提供取值函数）
    virtual int getPriceCode() = 0;

    //将原来Rental类中的getCharge移到该类中,并将租期作为参数传入
    //搬到这里来的原因是
    //1.switch语句中getPriceCode为本类对象的属性
    //2.封装影片类型的变化导致计算方式变化于该类中，从而降低对其他类的影响
    virtual double getCharge(int daysRented);

    int getFrequentRenterPoints(int daysRented);
};

//普通片：用子类取代类型码
class RegularMovie: public Movie
{
public:
    RegularMovie(string title);
    int getPriceCode();
    double getCharge(int daysRented);
};

//儿童片：
class ChildrensMovie: public Movie
{

public:
    ChildrensMovie(string title);
    int getPriceCode();
    double getCharge(int daysRented);
};

//新片
class ReleaseMovie: public Movie
{
public:
    ReleaseMovie(string title);
    int getPriceCode();
    double getCharge(int daysRented);
};

//租赁类（表示某个顾客租了一部影片）
class Rental
{
private:
    Movie&amp; movie;   //所租的影片
    int daysRented; //租期
public:
    Rental(Movie&amp; movie, int daysRented);

    int getDaysRented();

    Movie&amp; getMovie();

    double getCharge();

    //将原Customer类的statement中计算常客积分的代码移到Rental类
    int getFrequentRenterPoints();
};

//顾客类（用来表示顾客）
class Customer
{
private:
    string name; //顾客姓名
    vector&lt;Rental*&gt; rentals; //每个租赁记录

     //获得总消费
     double getTotalCharge();

     //获得总积分
    int getTotalFrequentRenterPointers();

     void cleanUp();

     template &lt;typename T&gt;
     string numToString(T num)
     {
        stringstream ss;
        ss &lt;&lt; num;
        return ss.str();
    }

public:
    Customer(string name);

    void addRental(Rental* value);
    string getName();

    //statement(报表)，生成租赁的详单
    string statement();

    ~Customer();
};</pre>
<p>//main.cpp</p>
<pre>//第1章：重构，第1个案例
//场景：影片出租，计算每一位顾客的消费金额
/*
说明：
1. 影片分3类：普通片、儿童片和新片。
2. 每种影片计算租金的方式。
   A.普通片：基本租金为2元，超过2天的部分每天加1.5元
   B.新片：租期*3
   C.儿童片：基本租金为1.5元，超过3天的部分每天加1.5元
3. 积分的计算：每借1片，积分加1，如果是新片且租期1天以上的额外赠送1分。
*/
#include &lt;iostream&gt;
#include "types.h"
using namespace std;

//*********************************************影片类*************************************
Movie::Movie(string title)
{
    this-&gt;title = title;
}
//提供创建子类实例的静态函数（也可以使用工厂方法）
Movie* Movie::createMovie(string title, int priceCode)
{
    Movie* ret = NULL;
    //利用子类替代switch的分支。我们总是在避免使用switch语句。但这里
    //只有一处用到switch,并且只用于决定创建何种对象而没有其他的业务逻辑
    //所以这样的switch语句是可以接受的。
    switch(priceCode)
    {
        case Movie::REGULAR:
            ret = new RegularMovie(title);
            break;
        case Movie::CHILDRENS:
            ret = new ChildrensMovie(title);
            break;
        case Movie::NEW_RELEASE:
            ret = new ReleaseMovie(title);
            break;
    }

    return ret;
}

string Movie::getTitle()
{
    return title;
}

void Movie::setTitle(string value)
{
    title = value;
}

double Movie::getCharge(int daysRented)
{
    return Movie::REGULAR;
}

//将原Rental类中常客积分搬到该类中
//原因是常客积分的计费方式与影片类型有关，也是为了控制当
//影片类型变化时，由于计算方式变化对其他类的影响
int Movie::getFrequentRenterPoints(int daysRented)
{
    //如果是新片且租期超过1天以上，则额外送1分积分
    if ((getPriceCode() == Movie::NEW_RELEASE) &amp;&amp;
        daysRented &gt; 1 )  return 2;
    else  return 1;
}

//普通片：用子类取代类型码
RegularMovie::RegularMovie(string title):Movie(title)
{
}

int RegularMovie::getPriceCode()
{
    return Movie::REGULAR;
}

//使用pushDownMethod(Field)方法将与特定类型码相关的函数推到子类来实现
double RegularMovie::getCharge(int daysRented)
{
    double result = 2 ;

    if(daysRented &gt; 2)  //超过2天的每天加1.5元
        result +=(daysRented - 2 ) * 1.5;

   return result;
}

//儿童片
ChildrensMovie::ChildrensMovie(string title):Movie(title)
{
}

int ChildrensMovie::getPriceCode()
{
    return Movie::CHILDRENS;
}

//使用pushDownMethod(Field)方法将与特定类型码相关的函数推到子类来实现
double ChildrensMovie::getCharge(int daysRented)
{
    double result = 1.5;//儿童片基本租金为1.5元

    if(daysRented &gt; 3)  //超过3天的每天加1.5元
        result +=(daysRented - 3 ) * 1.5;

    return result;
}

//新片
ReleaseMovie::ReleaseMovie(string title):Movie(title)
{
}

int ReleaseMovie::getPriceCode()
{
    return Movie::NEW_RELEASE;
}
//使用pushDownMethod(Field)方法将与特定类型码相关的函数推到子类来实现
double ReleaseMovie::getCharge(int daysRented)
{
    return  daysRented * 3;    //新片的租金
}

//********************************租赁类（表示某个顾客租了一部影片）**********************************
Rental::Rental(Movie&amp; movie, int daysRented):movie(movie)
{
    this-&gt;daysRented = daysRented;
}

int Rental::getDaysRented(){return daysRented;}

Movie&amp; Rental::getMovie()
{
    return movie;
}

double Rental::getCharge()
{
    return movie.getCharge(daysRented);
}

//将原Customer类的statement中计算常客积分的代码移到Rental类
int Rental::getFrequentRenterPoints()
{
    return movie.getFrequentRenterPoints(daysRented);
}

//*********************************顾客类（用来表示顾客）*************************************
//获得总消费
double Customer::getTotalCharge()
{
    double result = 0;
    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        Rental&amp; each = *(*iter);

        result += each.getCharge();

        ++iter;
    }
    return result;
}

 //获得总积分
int Customer::getTotalFrequentRenterPointers()
{
    int result = 0;

    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        Rental&amp; each = *(*iter);

        result += each.getFrequentRenterPoints();

        ++iter;
    }

    return result;
}

void Customer::cleanUp()
{
    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        delete(*iter);
        ++iter;
    }
    rentals.clear();
}

Customer::Customer(string name)
{
    this-&gt;name = name;
}

void Customer::addRental(Rental* value)
{
    rentals.push_back(value);
}

string Customer::getName(){return name;}

//statement(报表)，生成租赁的详单
string Customer::statement()
{
    string ret = "Rental Record for " + name + "\n";

    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        Rental&amp; each = *(*iter);

        //显示每个租赁记录

        ret += "\t" + each.getMovie().getTitle() + "\t" +
             numToString(each.getCharge())+ "\n";

        ++iter;
    }

    //增加页脚注释
    ret += "Amount owed is " + numToString(getTotalCharge()) + "\n";//用getTotalCharge代替totalAmount
    ret += "You earned " + numToString(getTotalFrequentRenterPointers()) +"\n";

    return ret;
}

Customer::~Customer()
{
    cleanUp();
}

//************************************************初始化数据********************************************

void init(Customer&amp; customer)
{
    Movie* mv = Movie::createMovie("倚天屠龙记",Movie::REGULAR);
    Rental* rt = new Rental(*mv, 2);
    customer.addRental(rt);

    mv = Movie::createMovie("新水浒传",Movie::NEW_RELEASE);
    rt = new Rental(*mv, 3);
    customer.addRental(rt);

    mv = Movie::createMovie("喜羊羊与灰太狼",Movie::CHILDRENS);
    rt = new Rental(*mv, 5);
    customer.addRental(rt);
}

int main()
{
    Customer customer("SantaClaus");
    init(customer);

    cout &lt;&lt; customer.statement() &lt;&lt;endl;

    return 0;
}
/*输出结果
Rental Record for SantaClaus
        倚天屠龙记      2
        新水浒传        9
        喜羊羊与灰太狼  4.5
Amount owed is 15.5
You earned 4
*/</pre>
<p><strong>3.3 </strong><strong>以state/strategy取代类型码</strong></p>
<p>（1）对象的<strong>状态在生命周期内可以变化</strong>，可以选用state模式（本例中有3种状态：REGULAR、CHILDREN、NEW_RELEASE）。而前一个例子中，<strong>对象与其状态是紧耦合的</strong>，本例<strong>利用state模式来组合对象与其状态，达到松耦合的目的</strong>。</p>
<p><strong>（2）重构的步骤</strong></p>
<p>　　①使用SelfEncapsulate Field来封装类型码，确保任何时候都通过取值和设值函数访问类型代码。</p>
<p>　　②新建一个Price类，并在其中提供类型相关的函数。如Price类中加入一个纯虚函数getPriceCode，并在所有子类中加上对应的具体函数。</p>
<p>　　③为Price添加子类，<strong>每个子类对应一种类型码</strong>。并提供getPriceCode的具体实现。</p>
<p>　　④利用pushDownMethod/Field方法将与类型码相关的函数从Price类推到子类去实现。（如getCharge、getFrequentRenterPoints函数）</p>
<p>　　⑤在Movie类中<strong>保存一个Price的引用</strong>，用来<strong>保存新建的状态对象</strong>。同时调整Movie中各个与类型码相关的函数，将<strong>动作转发到状态对象上</strong>（如Movie的getCharge函数）。</p>
<p><strong>（3）引入state模式的好处</strong></p>
<p>　　①如果要修改任何与价格有关的行为只需修改相应的子类即可。添加新的定价标准也只需扩展新的Price子类即可。</p>
<p>　　②<strong>修改影片分类结构</strong>或是<strong>改变费用的计算规则</strong>、<strong>改变常客积分</strong>计算规则都很容易。</p>
<p>【实例分析】影片出租1.3.3</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzc3Mjc1OS8yMDE2MTAvNzcyNzU5LTIwMTYxMDAxMjE1OTU0ODYwLTk4MjU5OTI0LnBuZw==.jpg" /></p>
<p>//types.h</p>
<pre>#include &lt;vector&gt;
#include &lt;string&gt;
#include &lt;sstream&gt;
using namespace std;

enum MovieType{
    REGULAR = 0, //普通片
    NEW_RELEASE, //新片
    CHILDRENS    //儿童片
};

//price类
class Price
{
public:
    virtual int getPriceCode() = 0;
    virtual double getCharge(int daysRented) = 0;
    virtual int getFrequentRenterPoints(int daysRented){return 1;}
    virtual ~Price(){}
};

//普通：
class RegularPrice: public Price
{
public:
    int getPriceCode();
    double getCharge(int daysRented);
};

//儿童片：
class ChildrensPrice: public Price
{
public:
    int getPriceCode();
    double getCharge(int daysRented);
};

//新片
class ReleasePrice: public Price
{
public:
    int getPriceCode();
    double getCharge(int daysRented);
    int getFrequentRenterPoints(int daysRented);
};

//影片类
class Movie
{
private:
    string title; //片名
    Price* price; //价格类

public:
    Movie(string title, int priceCode);
    ~Movie();

    string getTitle();
    void setTitle(string value);

    int getPriceCode();
    void setPriceCode(int priceCode);

    double getCharge(int daysRented);

    int getFrequentRenterPoints(int daysRented);
};

//租赁类（表示某个顾客租了一部影片）
class Rental
{
private:
    Movie&amp; movie;   //所租的影片
    int daysRented; //租期
public:
    Rental(Movie&amp; movie, int daysRented);

    int getDaysRented();

    Movie&amp; getMovie();

    double getCharge();

    //将原Customer类的statement中计算常客积分的代码移到Rental类
    int getFrequentRenterPoints();
};

//顾客类（用来表示顾客）
class Customer
{
private:
    string name; //顾客姓名
    vector&lt;Rental*&gt; rentals; //每个租赁记录

     //获得总消费
     double getTotalCharge();

     //获得总积分
    int getTotalFrequentRenterPointers();

     void cleanUp();

     template &lt;typename T&gt;
     string numToString(T num)
     {
        stringstream ss;
        ss &lt;&lt; num;
        return ss.str();
    }

public:
    Customer(string name);

    void addRental(Rental* value);
    string getName();

    //statement(报表)，生成租赁的详单
    string statement();

    ~Customer();
};</pre>
<p>//main.cpp</p>
<pre>//第1章：重构，第1个案例
//场景：影片出租，计算每一位顾客的消费金额
/*
说明：
1. 影片分3类：普通片、儿童片和新片。
2. 每种影片计算租金的方式。
   A.普通片：基本租金为2元，超过2天的部分每天加1.5元
   B.新片：租期*3
   C.儿童片：基本租金为1.5元，超过3天的部分每天加1.5元
3. 积分的计算：每借1片，积分加1，如果是新片且租期1天以上的额外赠送1分。
*/
#include &lt;iostream&gt;
#include "types.h"
using namespace std;

//*******************************************价格类**************************************
//普通片：用子类取代类型码
int RegularPrice::getPriceCode()
{
    return REGULAR;
}

//使用pushDownMethod(Field)方法将与特定类型码相关的函数推到子类来实现
double RegularPrice::getCharge(int daysRented)
{
    double result = 2 ;

    if(daysRented &gt; 2)  //超过2天的每天加1.5元
        result +=(daysRented - 2 ) * 1.5;

   return result;
}

//儿童片
int ChildrensPrice::getPriceCode()
{
    return CHILDRENS;
}

//使用pushDownMethod(Field)方法将与特定类型码相关的函数推到子类来实现
double ChildrensPrice::getCharge(int daysRented)
{
    double result = 1.5;//儿童片基本租金为1.5元

    if(daysRented &gt; 3)  //超过3天的每天加1.5元
        result +=(daysRented - 3 ) * 1.5;

    return result;
}

//新片
int ReleasePrice::getPriceCode()
{
    return NEW_RELEASE;
}
//使用pushDownMethod(Field)方法将与特定类型码相关的函数推到子类来实现
double ReleasePrice::getCharge(int daysRented)
{
    return  daysRented * 3;    //新片的租金
}

int ReleasePrice::getFrequentRenterPoints(int daysRented)
{
    return (daysRented &gt; 1) ? 2: 1;
}

//*********************************************影片类*************************************
Movie::Movie(string title, int priceCode):price(NULL)
{
    this-&gt;title = title;
    setPriceCode(priceCode);
}

string Movie::getTitle()
{
    return title;
}

void Movie::setTitle(string value)
{
    title = value;
}

int Movie::getPriceCode()
{
    return price-&gt;getPriceCode();
}

void Movie::setPriceCode(int priceCode)
{
    if (price != NULL)
        delete price;

    switch(priceCode)
    {
    case REGULAR:
        price = new RegularPrice();
        break;
    case CHILDRENS:
        price = new ChildrensPrice();
        break;
    case NEW_RELEASE:
        price = new ReleasePrice();
        break;
    }
}

double Movie::getCharge(int daysRented)
{
    double ret = 0;
    if (price != NULL)
        ret = price-&gt;getCharge(daysRented);
    return ret;
}

int Movie::getFrequentRenterPoints(int daysRented)
{
    return price-&gt;getFrequentRenterPoints(daysRented);
}

Movie::~Movie()
{
    delete price;
}

//********************************租赁类（表示某个顾客租了一部影片）**********************************
Rental::Rental(Movie&amp; movie, int daysRented):movie(movie)
{
    this-&gt;daysRented = daysRented;
}

int Rental::getDaysRented(){return daysRented;}

Movie&amp; Rental::getMovie()
{
    return movie;
}

double Rental::getCharge()
{
    return movie.getCharge(daysRented);
}

//将原Customer类的statement中计算常客积分的代码移到Rental类
int Rental::getFrequentRenterPoints()
{
    return movie.getFrequentRenterPoints(daysRented);
}

//*********************************顾客类（用来表示顾客）*************************************
//获得总消费
double Customer::getTotalCharge()
{
    double result = 0;
    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        Rental&amp; each = *(*iter);

        result += each.getCharge();

        ++iter;
    }
    return result;
}

 //获得总积分
int Customer::getTotalFrequentRenterPointers()
{
    int result = 0;

    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        Rental&amp; each = *(*iter);

        result += each.getFrequentRenterPoints();

        ++iter;
    }

    return result;
}

void Customer::cleanUp()
{
    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        delete(*iter);
        ++iter;
    }
    rentals.clear();
}

Customer::Customer(string name)
{
    this-&gt;name = name;
}

void Customer::addRental(Rental* value)
{
    rentals.push_back(value);
}

string Customer::getName(){return name;}

//statement(报表)，生成租赁的详单
string Customer::statement()
{
    string ret = "Rental Record for " + name + "\n";

    vector&lt;Rental*&gt;::iterator iter = rentals.begin();
    while( iter != rentals.end())
    {
        Rental&amp; each = *(*iter);

        //显示每个租赁记录

        ret += "\t" + each.getMovie().getTitle() + "\t" +
             numToString(each.getCharge())+ "\n";

        ++iter;
    }

    //增加页脚注释
    ret += "Amount owed is " + numToString(getTotalCharge()) + "\n";//用getTotalCharge代替totalAmount
    ret += "You earned " + numToString(getTotalFrequentRenterPointers()) +"\n";

    return ret;
}

Customer::~Customer()
{
    cleanUp();
}

//************************************************初始化数据********************************************

void init(Customer&amp; customer)
{
    Movie* mv = new Movie("倚天屠龙记", REGULAR);

    mv-&gt;setPriceCode(NEW_RELEASE); //重新改变影片的类型为NEW_RELEASE
                                   //这在上个例子是不可能的！

    Rental* rt = new Rental(*mv, 2);
    customer.addRental(rt);

    mv = new Movie("新水浒传", NEW_RELEASE);
    rt = new Rental(*mv, 3);
    customer.addRental(rt);

    mv = new Movie("喜羊羊与灰太狼", CHILDRENS);
    rt = new Rental(*mv, 5);
    customer.addRental(rt);
}

int main()
{
    Customer customer("SantaClaus");
    init(customer);

    cout &lt;&lt; customer.statement() &lt;&lt;endl;

    return 0;
}
/*输出结果
Rental Record for SantaClaus
        倚天屠龙记      6
        新水浒传        9
        喜羊羊与灰太狼  4.5
Amount owed is 19.5
You earned 5
*/</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 10:21:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>第1章 重构，第一个案例（3）：运用多态取代switch的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3q8bjz0.html" rel="bookmark">重构--第一个案例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1 起点 实例非常简单.这是一个影片出租店的程序,计算每一位顾客的消费金额并打印详单.操作者告诉程序:顾客租了哪些影片.租期多长,程序便根据租赁时间和影片类型算出费用.影片分为三类:普通片.儿童片和新片.除了计算费用,还要为常客计算积分,积分会根据租片种类是否为新片而有所不同. 我会逐一列出这些类的代码. Movie(影片) public class Movie { public static final int CHILDRENS = 2; public static final int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e8KWvM.html" rel="bookmark">第一章 重构，第一个案例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一章最前面的书中前面的话说得很有道理,一本授之以渔的书,开场就来历史.原理性的东西,很难勾起继续阅读的欲望,写书是这样,开会做分享亦然,所以作者精挑细选了一个代码规模不是很大并且能告诉我们很多重构的道理. 案例说明 这是一个非常简单的案例,展示了一个影片出租店用的程序,计算每一位顾客的消费金额并打印详单的模块,同时还需要计算每一位客人的积分.给出一个 UML 图,是最初版本. 抽象了三个实体:影片(片名.片类型).租赁(影片.租赁天数).顾客(姓名.租赁清单),代码详见下面的三个类以及 Mai			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wqmRVM.html" rel="bookmark">第十一章 重构和测试函数式程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第十一章重构和测试函数式程序 本章介绍 ■重构函数式程序 ■使用不变性推理代码 ■为 F# 程序写单元测试 ■使用延迟值缓存结果 这本书的主题之一就是,函数编程理如何使解代码更容易理解,只需要通过阅读就可以:特别是在需要修改陌生程序,或者通过组合现有函数实现行为,或者重构现有的代码时,尤为重要.函数式编程更容易重构,缘于清晰度和模块化:可以改善代码,并且有信心这种改变不会破坏程序的其他部分. 正如在函数式编中的很多事情一样,修改代码而不改变其含义的思想,与数学密切相关,因为不改变表达式含义的操作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lKVlPM.html" rel="bookmark">第15章WEB15-AJAX和JQuery案例篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今日任务? 使用AJAX完成用户名的异步校验? 使用JQuery完成用户名异步校验? 使用JQuery完成商品信息模糊显示? 使用JQuery完成省市联动效果返回XML? 使用JQuery完成省市联动效果返回JSON教学导航教学目标了解AJAX的基本使用掌握JQuery的AJAX部分的代码掌握JQuery返回XML和JSON格式数据如何处理教学方法案例驱动法1.1 上次课内容回顾:JDBC的添加,修改,删除查询. 查询: 在首页点击查询:提交到Servlet--调用业务层--调用DAO 添加:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQ68n3.html" rel="bookmark">学习ExtjsForVs&lpar;第一个案例HelloWord&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一个案例-Hello Word 1.本次练习以ext-4.0.7为例,首先从网上下载ext包. 2.打开包后将里面的三个文件或文件夹拷贝到项目中. resource文件夹 bootstrap.js ext-all.js 3. 在First-Hello.html中构建如下代码 1 &lt;!DOCTYPE html&gt; 2 &lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt; 3 &lt;head&gt; 4 &lt;meta http			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jnaNZ0.html" rel="bookmark">使用jqplot创建报表（一） 初学后写的第一个案例源码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.初学后写的第一个案例源码 效果图: 代码如下: &lt;%@ page language=&quot;java&quot; import=&quot;java.util.*&quot; pageEncoding=&quot;UTF-8&quot;%&gt; &lt;%@ include file=&quot;common.jsp&quot;%&gt; &lt;html&gt; &lt;head&gt; &lt;script type=&quot;text/javascript&quot; src=&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6X5ov3.html" rel="bookmark">重构第一天：封装集合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在一些情况下,在一个类中选择不去暴露整个集合给调用者是非常有必要的.比如当我们给一个集合添加/删除item时,我们需要添加一些额外的逻辑.因为这个原因,一个非常好的办法就是让暴露出来的collecction只能被迭代而不能被修改.让我们看下面的例子. public class Order { private List&lt;OrderLine&gt; _orderLines; public IEnumerable&lt;OrderLine&gt; OrderLines { get { return _or			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k6DQlM.html" rel="bookmark">Akka第一个案例动手实战开发环境的搭建</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习了Akka第一个案例动手实战开发环境的搭建, 采用IDEA 搭建AKKa的环境,快捷方便,相关的mave和其他的jar包可以自动加载. 王家林亲授&lt;DT大数据梦工厂&gt;大数据实战视频“Scala深入浅出实战经典”视频.音频和PPT下载!第92讲:Akka第一个案例动手实战开发环境的搭建 百度云盘:http://pan.baidu.com/s/1dDub8DN腾讯微云:http://url.cn/WYPW3Z360云盘:http://yunpan.cn/cm6u6NqEeLEeh  访问密码 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyNYKE0.html" rel="bookmark">使用SBT开发Akka第一个案例源码解析MapActor、ReduceActor、AggregateActor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习了使用SBT开发Akka第一个案例源码解析MapActor.ReduceActor.AggregateActor,应用MapActor对单词计数,发信息给ReduceActor,对信息进行local级的汇总,然后交给AggregateActor. 案例如下: class MapActor(reduceActor: ActorRef) extend Actor{ val STOP_WORDS_LIST=List(&quot;a&quot;,&quot;is&quot;) deg receive: Rec			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4JOP9M.html" rel="bookmark" class="title">css基础 给p标签中的内容 加粗，斜体，下划线，字体大小</a>
					<div>
						镇场诗: 清心感悟智慧语,不着世间名与利.学水处下纳百川,舍尽贡高我慢意. 学有小成返哺根,愿铸一良心博客.诚心于此写经验,愿见文者得启发.------------------------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0291BM.html" rel="bookmark" class="title">查看系统负载命令有哪些</a>
					<div>
						查看负载的命令有哪些? 一.uptime命令 1.uptime详解 uptime命令主要用于获取主机运行时间和查询linux系统负载等信息.uptime命令过去只显示系统运行多久.现在,可以显示系统已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47ppkDM.html" rel="bookmark" class="title">网络开发之《网络安全》</a>
					<div>
						用户标识: username password 设备标识: deviceid // imei/macaddr/flashid/rfid/buildid/uuid phonenumber 手机在您手上, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQJBN3.html" rel="bookmark" class="title">论创业者心态心智</a>
					<div>
						今天中午,我在缘创派发表了一个痛点,既然是痛点一般就是难以理解或难办到的,这是缘创派自己的援用李开复的话的本意对吧. 痛点大意内容:如果缘创派网站能助我找到我认为合适的伙伴,我想我可以直接给现金奖励该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awKzQ4.html" rel="bookmark" class="title">『Luogu OJ』『C&plus;&plus;』Level 1-2</a>
					<div>
						关卡1-2,3道题  顺序与分支 任务说明:计算机的智能性开始得以体现,因为计算机能够根据不同的条件选择了. 要完成这个任务,请将以下的题目都AC掉(即通过这道题目): 1.小玉家的电费 2.不高兴的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ennZJ3.html" rel="bookmark" class="title">2015第19周三小众app</a>
					<div>
						今天搜集下个人知道好玩的小众app: 1.开眼每日推荐5个小视频,世界那么大,一起来看看吧. 2.懒人周末周末去哪了?简洁美观 3.LOFTER 网易良心出品. 4.玩儿去 发现很多很多好玩的去处 5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7yKK3.html" rel="bookmark" class="title">I18N</a>
					<div>
						App.config &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot; ?&gt; &lt;configuration&gt; & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j7mqZ3.html" rel="bookmark" class="title">字符数组-返回字符串中的某个子串的开始位置，不使用string头文件-C</a>
					<div>
						简单的来讲就是把字符串进行比较,从第一个相同的位置开始,之后逐个比对,直到不相同为止,此时比较相同字符数目与子串长度的关系,相同则返回第一个相同位置,否则返回-1 1 #include&lt;stdi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rE7q70.html" rel="bookmark" class="title">7Python全栈之路系列之Django表单</a>
					<div>
						Python全栈之路系列之Django表单 从Request对象中获取数据 HttpRequest对象包含当前请求URL的一些信息: 熟悉/方法 描述 例如 request.path 除域名以外的请求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGyYBM.html" rel="bookmark" class="title">bzoj 3172</a>
					<div>
						3172: [Tjoi2013]单词 Time Limit: 10 Sec  Memory Limit: 512 MBSubmit: 3472  Solved: 1668[Submit][Status ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzQNgJ4.html" rel="bookmark" class="title">什么是软件需求？什么是功能需求？</a>
					<div>
						我们的软件产品或者项目,其需求都有三个层级和三个方面. 一.我们首先看需求的三个层次 软件需求包括3个不同的层次――业务需求.用户需求和功能需求. 业务需求 (Business requirement ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQpEk0.html" rel="bookmark" class="title">OpenGL ES 3&period;0之Texturting纹理详解（一）</a>
					<div>
						本文流程 1.Texturing基础 2.装载Texturing和mipmapping 3.纹理过滤和包装 4.Texture level-of-detail, swizzles, and depth ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONEx70.html" rel="bookmark" class="title">Cocos2d入门--2--三角函数的应用</a>
					<div>
						其实,三角函数的知识点是初中的数学基础.但是在编程里合理的利用的话,也会很好玩的,可以制作出很多有趣的动画特效. 首先要注意的是 角度 和 弧度 的转换. 360度 = 2×PI弧度 180度 =   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDv62Y3.html" rel="bookmark" class="title">单播，组播&lpar;多播&rpar;，广播以及任播</a>
					<div>
						目录 [+] 单播(unicast): 是指封包在计算机网络的传输中,目的地址为单一目标的一种传输方式.它是现今网络应用最为广泛,通常所使用的网络协议或服务大多采用单播传输,例如一切基于TCP的协议. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nYjxKM.html" rel="bookmark" class="title">HDU-4924-Football Manager&lpar;DFS&plus;DP&rpar;</a>
					<div>
						Problem Description Football Manager is a series of football management simulation games developed b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47w2ly4.html" rel="bookmark" class="title">对象的内存布局</a>
					<div>
						对象内存布局 在Hotspot虚拟机中,对象在内存中存储的布局可以分为三块区域:对象头,实例数据,对齐填充. 1.对象头 1.1 存储对象自身的运行时数据(mark word):哈希码,gc分代年龄. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5qbB3.html" rel="bookmark" class="title">c&plus;&plus;性能之对象与指针性能比较、以及java与c&plus;&plus;性能对比实测</a>
					<div>
						为了更加直观的比较,好吧,我们选择以对象的初始化并add到list为例子. 首先,定义object如下: #include &lt;string&gt; #pragma once using name ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41DQYG3.html" rel="bookmark" class="title">UVa 11743 - Credit Check</a>
					<div>
						题目:推断卡号是否合法,给你4组4位的数字.偶数位的2倍的位和加上奇数位的和,推断尾数是否为0. 分析:简单题,模拟. 直接依照提议推断就可以. 说明:460题,加油! #include &lt;io ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBKKa3.html" rel="bookmark" class="title">CentOS下配置JDK</a>
					<div>
						下面详细说一下CentOS下配置JDK的过程 首先按照约定俗成的习惯,将jdk放在/usr/local/java下,首先进入/usr/local然后新建一个目录java 然后我们需要下载最新的jdk程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6pWrW3.html" rel="bookmark" class="title">正在加载中-js&sol;jQuery功能实现</a>
					<div>
						前言 最近在springMVC中集成一个基于jsp报表工具,在集成之后的,由于报表运算量很大,SQL语句比较复杂,所以前台点击按钮触发以后,呆上几秒才有反应过来弹出报表框,所以想加入一个类似正在加载中 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
